#!/usr/bin/env python
# -*- coding:utf-8 -*-


# ############################################################################
#  license :
# ============================================================================
#
#  File :        Cmm.py
#
#  Project :     Cmm server
#
# This file is part of Tango device class.
# 
# Tango is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Tango is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with Tango.  If not, see <http://www.gnu.org/licenses/>.
# 
#
#  $Author :      alessandro.olivo$
#
#  $Revision :    $
#
#  $Date :        $
#
#  $HeadUrl :     $
# ============================================================================
#            This file is generated by POGO
#     (Program Obviously used to Generate tango Object)
# ############################################################################

__all__ = ["Cmm", "CmmClass", "main"]

__docformat__ = 'restructuredtext'

import PyTango
import sys
# Add additional import
#----- PROTECTED REGION ID(Cmm.additionnal_import) ENABLED START -----#
##############################################################################
# CVS strings automatically managed
# $Name:  $
# $Header: /home/cvsadm/cvsroot/fermi/servers/cmm/Cmm.py,v 1.3 2018-01-19 12:32:59 alessandro.olivo Exp $
# $Log: Cmm.py,v $
# Revision 1.3  2018-01-19 12:32:59  alessandro.olivo
# 1) Allow cvs to add source release on check out;
# 2) Improve exceptions managing;
# 3) Improve SysReset command feedback.
#
##############################################################################

import socket
import re

#----- PROTECTED REGION END -----#	//	Cmm.additionnal_import

# Device States Description
# No states for this device


class Cmm (PyTango.Device_5Impl):
    """"""
    
    # -------- Add you global variables here --------------------------
    #----- PROTECTED REGION ID(Cmm.global_variables) ENABLED START -----#
    
    #----- PROTECTED REGION END -----#	//	Cmm.global_variables

    def __init__(self, cl, name):
        PyTango.Device_5Impl.__init__(self,cl,name)
        self.debug_stream("In __init__()")
        Cmm.init_device(self)
        #----- PROTECTED REGION ID(Cmm.__init__) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	Cmm.__init__
        
    def delete_device(self):
        self.debug_stream("In delete_device()")
        #----- PROTECTED REGION ID(Cmm.delete_device) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	Cmm.delete_device

    def init_device(self):
        self.debug_stream("In init_device()")
        self.get_device_properties(self.get_device_class())
        self.attr_ECHostname_read = [""]
        #----- PROTECTED REGION ID(Cmm.init_device) ENABLED START -----#
        self.mandatory_not_defined = False
        self.property_not_correct = False
        self.check_mandatory_property()
        if self.mandatory_not_defined:
            print self.get_status()
            return

        try:
            socket.gethostbyname(self.Hostname)
        except socket.gaierror:
            self.mandatory_not_defined = True 
            self.set_state(PyTango.DevState.FAULT)
            self.set_status("The inserted hostname \"" + self.Hostname + "\""
	                    " doesn't exist")
            print self.get_status()
	    return

        print "Ready to accept request"
        #----- PROTECTED REGION END -----#	//	Cmm.init_device

    def always_executed_hook(self):
        self.debug_stream("In always_excuted_hook()")
        #----- PROTECTED REGION ID(Cmm.always_executed_hook) ENABLED START -----#
        if self.mandatory_not_defined:
            PyTango.Except.throw_exception("PROPERTY_NOT_SET",
                                           self.get_status(),
                                           "In always_excuted_hook()")
        if self.property_not_correct:
            PyTango.Except.throw_exception("PROPERTY_NOT_CORRECT",
                                           self.get_status(),
                                           "In always_excuted_hook()")
        #----- PROTECTED REGION END -----#	//	Cmm.always_executed_hook

    # -------------------------------------------------------------------------
    #    Cmm read/write attribute methods
    # -------------------------------------------------------------------------
    
    def read_ECHostname(self, attr):
        self.debug_stream("In read_ECHostname()")
        #----- PROTECTED REGION ID(Cmm.ECHostname_read) ENABLED START -----#
        self.attr_ECHostname_read = self.ECHostname
        attr.set_value(self.attr_ECHostname_read)
        
        #----- PROTECTED REGION END -----#	//	Cmm.ECHostname_read
        
    
    
            
    def read_attr_hardware(self, data):
        self.debug_stream("In read_attr_hardware()")
        #----- PROTECTED REGION ID(Cmm.read_attr_hardware) ENABLED START -----#


        #----- PROTECTED REGION END -----#	//	Cmm.read_attr_hardware


    # -------------------------------------------------------------------------
    #    Cmm command methods
    # -------------------------------------------------------------------------
    
    def dev_state(self):
        """ This command gets the device state (stored in its device_state data member) and returns it to the caller.
        :return: Device state
        :rtype: PyTango.CmdArgType.DevState
        """
        self.debug_stream("In dev_state()")
        argout = PyTango.DevState.UNKNOWN
        #----- PROTECTED REGION ID(Cmm.State) ENABLED START -----#
        s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        s.settimeout(self.Timeout)
        try:
            s.connect((self.Hostname, 80))
            argout = PyTango.DevState.ON
        except Exception as e:
            argout = PyTango.DevState.FAULT
        finally:
            s.shutdown(socket.SHUT_RDWR)
            s.close()
        self.set_state(argout)

        #----- PROTECTED REGION END -----#	//	Cmm.State
        if argout != PyTango.DevState.ALARM:
            PyTango.Device_4Impl.dev_state(self)
        return self.get_state()
        
    def dev_status(self):
        """ This command gets the device status (stored in its device_status data member) and returns it to the caller.
        :return: Device status
        :rtype: PyTango.ConstDevString
        """
        self.debug_stream("In dev_status()")
        argout = ""
        #----- PROTECTED REGION ID(Cmm.Status) ENABLED START -----#
        s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        s.settimeout(self.Timeout)
        try:
            s.connect((self.Hostname, 80))
            argout = "TCP connection to the device is available"
        except Exception as e:
            argout = "Device web server is not reachable.\nError details:\n"\
	             + str(e)
        finally:
            s.shutdown(socket.SHUT_RDWR)
            s.close()
        self.argout = argout
        
        #----- PROTECTED REGION END -----#	//	Cmm.Status
        self.set_status(self.argout)
        self.__status = PyTango.Device_4Impl.dev_status(self)
        return self.__status
        
    def SysReset(self):
        """ Reset the VMEbus system.
        """
        self.debug_stream("In SysReset()")
        #----- PROTECTED REGION ID(Cmm.SysReset) ENABLED START -----#
        request_url = "/sysres.cgi?sysres=System+Reset"
        s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        s.settimeout(self.Timeout)
        resp = ""
        try:
            s.connect((self.Hostname, 80))
            s.sendall("GET " + request_url)
            resp = s.recv(1024).splitlines()[0]
        except Exception as e:
            PyTango.Except.throw_exception(
                "Problems occurred during TCP connection to the device web server"
                " (Error: " + str(e) + " )",
                "VME System may not have been reset",
                "In SysReset()")
        finally:
            s.shutdown(socket.SHUT_RDWR)
            s.close()

        if resp != "HTTP/1.0 200 OK":
            PyTango.Except.throw_exception(
                "Http response not expected (Error: " + resp + " )",
                "VME System may not have been reset",
                "In SysReset()")
        
        #----- PROTECTED REGION END -----#	//	Cmm.SysReset
        

    #----- PROTECTED REGION ID(Cmm.programmer_methods) ENABLED START -----#

    # -------------------------------------------------------------------------
    #    Cmm helper methods
    # -------------------------------------------------------------------------

    def check_mandatory_property(self):
        self.debug_stream("In check_mandatory_property()")

        if not self.Hostname:
            self.mandatory_not_defined = True
            self.set_state(PyTango.DevState.FAULT)
            self.set_status("\"Hostname\" is mandatory property"
                            + " but is not defined in database")
        
    #----- PROTECTED REGION END -----#	//	Cmm.programmer_methods

class CmmClass(PyTango.DeviceClass):
    # -------- Add you global class variables here --------------------------
    #----- PROTECTED REGION ID(Cmm.global_class_variables) ENABLED START -----#
    
    #----- PROTECTED REGION END -----#	//	Cmm.global_class_variables


    #    Class Properties
    class_property_list = {
        }


    #    Device Properties
    device_property_list = {
        'Hostname':
            [PyTango.DevString, 
            "Cmm hostname",
            [] ],
        'ECHostname':
            [PyTango.DevVarStringArray, 
            "Hostname of the EC(s) managed by the CMM",
            [] ],
        'Timeout':
            [PyTango.DevUShort, 
            "TCP connection timeout",
            [1]],
        }


    #    Command definitions
    cmd_list = {
        'SysReset':
            [[PyTango.DevVoid, "none"],
            [PyTango.DevVoid, "none"]],
        }


    #    Attribute definitions
    attr_list = {
        'ECHostname':
            [[PyTango.DevString,
            PyTango.SPECTRUM,
            PyTango.READ, 21]],
        }


def main():
    try:
        py = PyTango.Util(sys.argv)
        py.add_class(CmmClass, Cmm, 'Cmm')
        #----- PROTECTED REGION ID(Cmm.add_classes) ENABLED START -----#
    
        #----- PROTECTED REGION END -----#	//	Cmm.add_classes

        U = PyTango.Util.instance()
        U.server_init()
        U.server_run()

    except PyTango.DevFailed as e:
        print ('-------> Received a DevFailed exception:', e)
    except Exception as e:
        print ('-------> An unforeseen exception occured....', e)

if __name__ == '__main__':
    main()
